Attribute VB_Name = "Module1"
' Have a lot of dates to manipulate in your
' applications?
' Ever considered the space wasted on disk storage?
'
' Then look at these handy functions to reduce
' the overhead by 70%.
'
' This demo shows how to compress a 10 character
' date into 3 bytes, thereby saving disk storage,
' and restore the dates upon retrieval back to 10 bytes.
' Just type a date into the 1e text-box
' and press ENTER.
'
' Full entry error checking for:
' valid separator, valid month, day and leap year
'
' IMPORTANT NOTE: Date cannot be before 1961.
' Explanation:
' CHR$ 0 to 255 are 1 byte long
' Day = 1 to 31 so use Chr$(1 to 31)
' Month = 1 to 12 so use Chr$(1 to 12)
' Year is always greater than 255 so in order to
' store it into 1 byte, we must subtract some value.
' Taking off 1960 allows us to use the routine AS IS
' until the year 2215.
'
' Enjoy ...
'
'***************************************
' Author's E-Mail: bguffens@belgacom.net
'***************************************

Dim Numdays(1 To 12) As Integer 'Days in each month
Function ValidDate(A$)
  Dim MO$(1 To 12)
  MO$(1) = "Januari"
  MO$(2) = "Februari"
  MO$(3) = "March"
  MO$(4) = "April"
  MO$(5) = "Mai"
  MO$(6) = "June"
  MO$(7) = July
  MO$(8) = "August"
  MO$(9) = "September"
  MO$(10) = "October"
  MO$(11) = "November"
  MO$(12) = "December"
  'Look for lenght
  If Len(A$) <> 10 Then
    MsgBox " Illegal Date-Lenght. Must be 10 Characters.", , " Wrong Date"
    ValidDate = False
    Exit Function
  End If
 '**************************************************
  'Look for separators
  'Other countries, adjust for "/", "." as needed
  'If you block the next 4 lines then any separator
  'is acceptable
  '**************************************************
  If Mid$(A$, 3, 1) <> "-" Or Mid$(A$, 6, 1) <> "-" Then
    MsgBox " Illegal Separator = ''-'')", , " Wrong Date"
    ValidDate = False
    Exit Function
  End If
  'Look for valid # of days for Month in given year
  YY = Val(Mid$(A$, 7))     'Year
  GetDays (YY)
  m1 = Val(Mid$(A$, 4, 2))  'Month
  If m1 < 1 Or m1 > 12 Then
    MsgBox " Illegal Month-Number."
    ValidDate = False
    Exit Function
  End If
  MD = Numdays(m1)          '# of days in Month
  D1 = Val(Left$(A$, 2))    'Day given
  If D1 < 1 Or D1 > MD Then
    MsgBox " There are no " & Str$(D1) & " Days in the month " & MO$(m1) & Str$(YY), , " Wrong Date "
    ValidDate = False
    Exit Function
  End If
  ValidDate = True
End Function


Sub GetDays(Y)
'Find # of days in EACH Month for a GIVEN Year (Y)
  Dim J As Integer
  O# = DateSerial(Y, 1, 1)  '1e Month
  For J = 2 To 13           'consecutive Months
    N# = DateSerial(Y, J, 1)
    Numdays(J - 1) = Abs(O# - N#)
    O# = N#
  Next J
End Sub


Function fUC$(A1$)
  'Uncompress 3 bytes into 10 bytes date
  'and add zero's where needed
  '**************************************
  ' Change seperator to "/" if applicable
  '**************************************
  FUNC$ = Right$(Str$(Asc(Mid$(A1$, 1))), 2) & _
  "-" & Right$(Str$(Asc(Mid$(A1$, 2))), 2) & _
  "-" & Right$(Str$(Asc(Mid$(A1$, 3))), 2) + 1960
  If Mid$(FUNC$, 1, 1) = " " Then Mid$(FUNC$, 1, 1) = "0"
  If Mid$(FUNC$, 4, 1) = " " Then Mid$(FUNC$, 4, 1) = "0"
  fUC$ = FUNC$
End Function


Function fCD$(A1$)
  'Compress 10 bytes date into 3 bytes
  fCD$ = Chr$(Val(Mid$(A1$, 1, 2))) & _
  Chr$(Val(Mid$(A1$, 4, 2))) & _
  Chr$(Val(Mid$(A1$, 7, 4)) - 1960)
End Function

